 /* Digital Voltmeter  using 74HC595A
5.01.2013
 */

 sbit Data_Pin at GP0_bit;
 sbit Clk_Pin at GP1_bit;
 sbit Enable_Pin at GP2_bit;

 // Always mention this definition statement
 unsigned short p, q,  Mask, N,t, RS, Flag, temp;

 void Delay_50ms(){
  Delay_ms(50);
 }


  void Write_LCD_all(unsigned short N){
  Enable_Pin = 0;
  // ****** Write RS *********
  Clk_Pin = 0;
  // ****** End RS Write

  // Shift in 8 bits
  Mask = 0x01;
   for (t=0; t<8; t++){
    Flag = N & Mask;
    if(Flag==0) Data_Pin = 0;
    else Data_Pin = 1;
    Clk_Pin = 1;
    Delay_us(1);
    Clk_Pin = 0;
    Mask = Mask << 1;
   }
   // One more clock because SC and ST clks are tied
   Clk_Pin = 1;
   Delay_us(1);
   Clk_Pin = 0;
   Data_Pin = RS;
   Enable_Pin = 1;
 //  Delay_us(111);
   Enable_Pin = 0;
  // Delay_us(111);
 }
 
  void Write_LCD_Data(unsigned short D){
  RS = 1; // It is Data, not command
  Write_LCD_all (D);
  }

 void Write_LCD_Cmd(unsigned short C){
  RS = 0; // It is command, not data
  Write_LCD_all (C);
 }

 void Initialize_LCD(){
  Delay_50ms();
  Delay_50ms();
  Delay_50ms();
  Delay_50ms();
  Delay_50ms();
 //Write_LCD_Cmd(0x20); // Wake-Up Sequence
  //Delay_50ms();
  //Write_LCD_Cmd(0x20);
  //Delay_50ms();
  //Write_LCD_Cmd(0x20);
  //Delay_50ms();
  Write_LCD_Cmd(0x38); // 8-bits, 2 lines, 5x7 font
  Delay_50ms();
  Write_LCD_Cmd(0x0C); // Display ON, No cursors
  Delay_50ms();
  Write_LCD_Cmd(0x06); // Entry mode- Auto-increment, No Display shifting
  Delay_50ms();
  Write_LCD_Cmd(0x01);
  Delay_50ms();
 }

 void Position_LCD(unsigned short x, unsigned short y){
  temp = 127 + y;
  if (x == 2) temp = temp + 64;
  Write_LCD_Cmd(temp);
 }

 void Write_LCD_Text(char *StrData){
  for (p = 0; p < strlen(StrData); p++){
   temp = StrData[p];
   Write_LCD_Data(temp);
  }

 }

 char Message1[] = "VOLTMETER";
 unsigned int DisplayVolt, MAS[16];
 char *volt = "00.0";

 void main() {
 CMCON0 = 7;  // Disable Comparators
 TRISIO = 0b00011000;  // All Outputs, except GP4 and GP3
 ANSEL = 0b00001000; // GP4 analog i/p
 GPIO = 0;

 Initialize_LCD();
 Position_LCD(1,3);
 Write_LCD_Text(Message1);
 Position_LCD(2,9);
 Write_LCD_Data('V');

 for (p = 0; p < 16; p++){
  MAS[p] = ADC_Read(3);
  //delay_ms(100);
 }

 q =0;

 do {

  DisplayVolt=0;
   for (p = 0; p < 16; p++){
   DisplayVolt = DisplayVolt + MAS[p];
  }

  DisplayVolt = DisplayVolt >> 3;

  volt[0] = DisplayVolt/1000 + 48;
  volt[1] = (DisplayVolt/100)%10 + 48;
  volt[3] = (DisplayVolt/10)%10 + 48;

  if(volt[1]>9+48) {
   volt[1]=48;
   volt[0]++;
    if(volt[3]>9+48) {
     volt[3]=48;
     volt[1]++;
      if(DisplayVolt%10>4) {
      volt[3]++;
     }
    }
   }
  //volt[4] = DisplayVolt%10 + 48;

  Position_LCD(2,4);
  Write_LCD_Text(volt);
  delay_ms(100);

  MAS[q] = ADC_Read(3);
   if(q==15) q = 0;
   else q++;

 } while(1);

 }